--[[
todo:
	color changing according to revives left/high downs?
	colorpicker support/reference color strings in settings for colors
	"smart" max lives tracking- if a teammate (who does not have revive syncing via DownCounter) goes x downs before going into custody, set that number as the teammate's new max downs
	spam avoidance- set only the highest peer id player to be the designated downcounter announcer
--]]

--alert messages and conditions thereof are handled in the caller function hook
--hud counter is handled in DownCounterStandalone's setter function for downs or revives


_G.DownCounterStandalone = _G.DownCounterStandalone or {}
DownCounterStandalone.ModID_LEGACY = "DownCounterStandalone"
DownCounterStandalone.ModID = "DownCounter_r2"
DownCounterStandalone.CHAT_PREFIX = "[Down Counter]"
DownCounterStandalone.NETWORK_MESSAGE_UNREGISTER = "unregister"

DownCounterStandalone._path = ModPath
DownCounterStandalone._localization_path = ModPath .. "loc/"
DownCounterStandalone._data_path = SavePath .. "downcounter_standalone.txt"

--here for reference
DownCounterStandalone.MAX_LIVES = DownCounterStandalone.MAX_LIVES or nil

DownCounterStandalone.ANNOUNCE_DEAD_VARIANT_CHANCE = 0.01
DownCounterStandalone.LOW_LIVES_THRESHOLD = 1
DownCounterStandalone.LOW_DOWNS_SHAMING_THRESHOLD = 0

DownCounterStandalone.FONT_NAME = "fonts/font_medium_mf"
DownCounterStandalone.FONT_SIZE = 22
DownCounterStandalone.VALIGN = "center"
DownCounterStandalone.HALIGN = "center"

DownCounterStandalone.default_settings = {
	hudmode = true,--if true, renders hud counter. if false, does not do that thing i just said
	networking_enabled = true, --if true, sends and receives downs data to peers- this way, players with Down Counter installed will have accurate downs/revives counts between them
	announce_chat_mode = 2,
	--modes can be 1 (off), 2 (local only [default]), or 3 (announce in chat to all)
	
	legacy_support = true, --if true, will attempt to interpret networking data from players with older versions of DownCounterStandalone (v2.02 and earlier)

	announce_alert_mode = 3,
	--modes can be 1 (all players' stats [default]), 2 (only your teams' stats), 3 (only your stats)
	--***design option 2:
	--   allow each individual player to announce their own instead? but so much work to manage clients who do/don't have the mod
	
		--downs and docbag replenishes, if you REALLY want to micromanage them)
	show_teammate_revives = false, --this has to guess
	show_player_revives = true,
	
	announce_custody = false,
	announce_docbags = false,
	announce_extras = false, --announces other things like being tased, cloaked, cuffed. warning: extremely annoying
	only_announce_lowdowns_mode = true,
	--bool; if true, only announce downs when player is "black and white:" on their last down (cannot account for Nine Lives Aced unless that player has this mod)
	
	logging_enabled = false
}
DownCounterStandalone.settings = table.deep_map_copy(DownCounterStandalone.default_settings)

--this is only used for vanilla players
DownCounterStandalone.counter = DownCounterStandalone.counter or {
	[1] = 0,
	[2] = 0,
	[3] = 0,
	[4] = 0,
	[5] = 0,
	[420] = 0
}

DownCounterStandalone.color_data = {
	dead = Color.red:with_alpha(0.6),
	not_dead = Color.white:with_alpha(0.8),
	
	counter_revives = Color("80f409"),
	counter_downs = Color("f47d09"),
	
	revives_low = Color.red:with_alpha(0.6),
	revives_high = Color.white:with_alpha(0.8),
	downs = Color(0.5,0.5,0.5):with_alpha(0.6)
}
DownCounterStandalone._docbag_shaming_messages = {
	fp = {
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_1",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_2",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_3",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_4",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_5",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_6",
		"hud_dcs_announcement_criminal_bad_at_video_games_fp_7"
	},
	third = {
		"hud_dcs_announcement_criminal_bad_at_video_games_3p_1",
		"hud_dcs_announcement_criminal_bad_at_video_games_3p_2",
		"hud_dcs_announcement_criminal_bad_at_video_games_3p_3"
	}
}



Hooks:Register("dcs_standalone_on_revives_changed")
Hooks:Register("dcs_standalone_on_downs_changed")

Hooks:Add("dcs_standalone_on_revives_changed","dcs_sync_revives_out",function(peer_id,revives,prev_revives)
	if peer_id == LuaNetworking:LocalPeerID() then 
		DownCounterStandalone:SendDownsDataToAll()
	end
end)


Hooks:Add("NetworkReceivedData", "downcounter_receivenetworkdata", function(sender, message, data, ...)
	if not DownCounterStandalone:IsNetworkingEnabled() then 
		return 
	end
	
	if message == DownCounterStandalone.ModID then
		
		local peer = managers.network:session():peer(sender)
		if peer then
			if DownCounterStandalone:IsNetworkingEnabled() then 
				if data == DownCounterStandalone.NETWORK_MESSAGE_UNREGISTER then 
					peer.dcs_installed = false
				else
					local split_data = string.split(data,":")
					local max_lives = split_data and split_data[2]
					local current_lives = split_data and split_data[4]
					current_lives = current_lives and tonumber(current_lives)

					if max_lives then 
						peer.dcs_max_lives = tonumber(max_lives) or peer.dcs_max_lives
					end
					if current_lives then 
						--peer.dcs_current_lives = current_lives
--						DownCounterStandalone:_log("Setting current revives " .. tostring(current_lives) .. " from sender " .. tostring(sender))
						DownCounterStandalone:SetRevives(sender,current_lives)
					else
--						DownCounterStandalone:_log("No current lives found in string " .. tostring(data))
					end
					peer.dcs_installed = true
				end
				
			end
			
		end
	elseif message == DownCounterStandalone.ModID_LEGACY then --for v2.02 and earlier
		if DownCounterStandalone:IsLegacyNetworkingEnabled() then
			local peer = managers.network:session():peer(sender)
			if peer then
			
				local split_data = string.split(data,":")
				local extra_lives = split_data and split_data[2]
				local existing_downs = split_data and split_data[4]
				existing_downs = existing_downs and tonumber(existing_downs) or 0
				
				peer.dcs_max_lives = (tonumber(extra_lives) or 0) + DownCounterStandalone:GetMaxRevives()
				peer.dcs_current_lives = peer.dcs_max_lives - existing_downs
	--			DownCounterStandalone.counter[sender] = existing_downs
	--			DownCounterStandalone:SetHUDCounter(sender,existing_downs)
			end
		end
	end
end)

function DownCounterStandalone:_log(s,...)
	if self.settings.logging_enabled then
		if _G.Log then 
			return Log("DownCounter: " .. tostring(s),...)
		else
			return log("DownCounter: " .. tostring(s),...)
		end
	end
end


--hooking to hudteammate is not reliable in some cases involving mod conflicts with some HUD mods; move the hud setter to here to ensure its initiation
--in addition to preventing possible crashes from mod conflicts, this should allow for implementing better custom HUD compatibility in the future
--(note to self, check menucallbackhandler for other instances of referencing teammate panels)
function DownCounterStandalone._set_downs_amount_string(panel,amount)
	if DownCounterStandalone:IsHUDEnabled() then
		local radial_health_panel = panel._radial_health_panel
		local downcounter_text = alive(radial_health_panel) and radial_health_panel:child("downcounter_text")		
		if not alive(downcounter_text) then
			DownCounterStandalone:_log("_set_downs_amount_string(): No DownCounterStandalone HUD element present. Please ensure that you don't have HUD mod conflicts that could prevent DownCounterStandalone from creating its HUD element.")
			return
		end
		if type(amount) == "number" then 
			downcounter_text:set_text(string.format("%i",amount))
		else
			downcounter_text:set_text("")
		end
	end
end

function DownCounterStandalone._set_downs_amount_color(panel,color)
	local radial_health_panel = panel._radial_health_panel
	local downcounter_text = alive(radial_health_panel) and radial_health_panel:child("downcounter_text")	
	if not alive(downcounter_text) then
		return
	end
	downcounter_text:set_color(color)
end

function DownCounterStandalone:GetMaxRevives(peer_id,force_refresh) --gets the global number of max downs (this may become outdated if payday 2 updates)

	local session = managers.network and managers.network:session()

	if not session then return end

	local lives = self.MAX_LIVES
	if force_refresh or not lives then
		--calculate max number of lives
		lives = tweak_data.player.damage.LIVES_INIT

		if Global.game_settings.one_down then
			lives = 2
		end

		lives = managers.modifiers:modify_value("PlayerDamage:GetMaximumLives", lives)
		
		self.MAX_LIVES = lives
	end
	if peer_id then 
		if peer_id == session:local_peer():id() then 
			local player = managers.player and managers.player:local_player()
			if alive(player) then 
				lives = player:character_damage()._lives_init or lives
			end
		end

		local peer = session and session:peer(peer_id) 
		if peer then
			lives = peer.dcs_max_lives or lives
--			if force_refresh then 
--				peer.dcs_max_lives = lives
--			end
		end
	end
	return lives
end

--should only be used for peers who have this down counter mod
function DownCounterStandalone:SetRevives(peer_id,revives)
	local prev_revives
	local session = managers.network and managers.network:session()
	local peer = session and session:peer(peer_id)
	if peer_id == LuaNetworking:LocalPeerID() then 
		local local_peer = managers.network:session():local_peer()
		if local_peer then
			local_peer.dcs_current_lives = revives
		end
		if self:ShouldShowPlayerRevives() then 
			self:SetHUDCounter(peer_id,revives)	
		end
	elseif peer then 
		prev_revives = peer.dcs_current_lives
		peer.dcs_current_lives = revives
		if DownCounterStandalone:ShouldShowTeammateRevives() then
			self:SetHUDCounter(peer_id,revives)	
		end
	else 
--		self:_log("ERROR: No peer found. SetRevives(" .. tostring(peer_id) .. "," .. tostring(revives) .. "," .. tostring(do_hud) .. ")")
	end
	
	Hooks:Call("dcs_standalone_on_revives_changed",peer_id,revives,prev_revives)
end

--tracks other players' downs as they appear to you, the client; NOT to be called as a result of received network data
function DownCounterStandalone:SetDowns(peer_id,downs,skip_hud)
	local prev_downs = self.counter[peer_id]
	self.counter[peer_id] = downs
	
	if self:IsHUDEnabled() and not skip_hud then 
		local num
		if peer_id ~= LuaNetworking:LocalPeerID() then 
			local session = managers.network and managers.network:session()
			local peer = session and session:peer(peer_id)
			
			if peer then
				if not self:ShouldShowTeammateRevives() then
					num = downs
				elseif not self:IsPeerModded(peer_id,peer) then
					--guess if teammate does not have DCS (ie. more reliable information is not available)
					num = self:GetMaxRevives(peer_id) - downs
				end
			end
		elseif not self:ShouldShowPlayerRevives() then 
			num = downs
		end
		if num then 
			self:SetHUDCounter(peer_id,num)
		end
	end
	Hooks:Call("dcs_standalone_on_downs_changed",peer_id,downs,prev_downs)
end

function DownCounterStandalone:IsPeerModded(peer_id,peer)
	peer = peer or (peer_id and managers.network and managers.network:session() and managers.network:session():peer(peer_id))
	if peer then 
		return peer.dcs_installed and true or false
	end
end

function DownCounterStandalone:GetRevives(peer_id)
	local session = managers.network and managers.network:session()
	if session then 
		if peer_id == session:local_peer():id() then 
			local player = managers.player and managers.player:local_player()
			if alive(player) then 
				return player:character_damage():get_revives()
			else
				return 0 --changed my mind actually, 0 is fine. found a workaround for the join-in-progress inaccurate down/revives counts
				
--				self:GetMaxRevives(peer_id) --if a teammate is joining your game in progress, their downs should show as max, not 0
			end
		else
			local peer = session and session:peer(peer_id)
			if peer and peer.dcs_current_lives then 
				return peer.dcs_current_lives
			end
		end
	end
	return self:GetMaxRevives(peer_id) - self:GetDowns(peer_id)
end

function DownCounterStandalone:GetDowns(peer_id)
--[[
	local session = managers.network and managers.network:session()
	local peer = session and session:peer(peer_id)
	if peer then 
		if peer.current_lives then 
			return self:GetMaxRevives(peer_id) - peer.current_lives
		end
	end
	--]]
	return self.counter[peer_id]
end

function DownCounterStandalone:GetFormattedDownsData()
	local peer_id = LuaNetworking:LocalPeerID()
	local extra_lives = self:GetMaxRevives(peer_id)
	local my_downs = self:GetRevives(peer_id)
	if not (managers.player and alive(managers.player:local_player())) then 
		my_downs = extra_lives
	end
	return "LivesMax:" .. tostring(extra_lives) .. ":LivesCurrent:" .. tostring(my_downs)
end

--sends your max revives number and your current revives number to other players
function DownCounterStandalone:SendDownsDataToAll()
	if managers.network:session() then 
		local message = self:GetFormattedDownsData()
		LuaNetworking:SendToPeers(DownCounterStandalone.ModID, message)
	else
--		self:_log("Error: No session found")
	end
end

function DownCounterStandalone:SendDownsData(peer_id)
	if not peer_id then 
		return
	end
	local message = self:GetFormattedDownsData()
	LuaNetworking:SendToPeer(peer_id,DownCounterStandalone.ModID, message)
end

function DownCounterStandalone:Announce(message)
	if DownCounterStandalone:IsChatModeMuted() then
		return
	elseif DownCounterStandalone:IsChatModeLocal() then
		DownCounterStandalone:AnnounceToSelf(message)
	elseif DownCounterStandalone:IsChatModeGlobal() then
		DownCounterStandalone:AnnounceToAll(message)
	end
end

function DownCounterStandalone:AnnounceToAll(message)
	managers.chat:send_message(ChatManager.GAME, managers.network.account:username() or "Offline", self.CHAT_PREFIX .. " " .. tostring(message))		
end

function DownCounterStandalone:AnnounceToSelf(message)
	managers.chat:_receive_message(1,self.CHAT_PREFIX, tostring(message), Color('fce538'))
end

function DownCounterStandalone:IsAnnounceLowDownsOnly()
	return DownCounterStandalone.settings.only_announce_lowdowns_mode
end

function DownCounterStandalone:ShouldShowPlayerRevives()
	return self.settings.show_player_revives
end

function DownCounterStandalone:ShouldShowTeammateRevives()
	return self.settings.show_teammate_revives
end

function DownCounterStandalone:AnnounceDocBags()
	return DownCounterStandalone.settings.announce_docbags
end

function DownCounterStandalone:AnnounceCustodies() --why did i make this plural. it's singular "custody" everywhere else, rip consistency
	return DownCounterStandalone.settings.announce_custody
end

function DownCounterStandalone:AnnounceExtraStates()
	return DownCounterStandalone.settings.announce_extras
end

function DownCounterStandalone:IsNetworkingEnabled()
	return DownCounterStandalone.settings.networking_enabled
end

function DownCounterStandalone:IsLegacyNetworkingEnabled() 
	return self.settings.legacy_support
end

function DownCounterStandalone:IsChatModeMuted()
	return DownCounterStandalone.settings.announce_chat_mode == 1
end

function DownCounterStandalone:IsChatModeLocal()
	return DownCounterStandalone.settings.announce_chat_mode == 2
end

function DownCounterStandalone:IsChatModeGlobal()
	return DownCounterStandalone.settings.announce_chat_mode == 3
end

function DownCounterStandalone:IsAlertModeAll()
	return DownCounterStandalone.settings.announce_alert_mode == 1
end

function DownCounterStandalone:IsAlertModeTeammates()
	return DownCounterStandalone.settings.announce_alert_mode == 2
end

function DownCounterStandalone:IsAlertModeSelf()
	return DownCounterStandalone.settings.announce_alert_mode == 3
end

function DownCounterStandalone:SetHUDCounter(peer_id,num)
	if managers.hud and managers.hud._teammate_panels and peer_id then 
		local my_peer_id = managers.network:session():local_peer():id()
		for _,panel in pairs(managers.hud._teammate_panels) do 
			if (panel._peer_id == peer_id) or (peer_id == my_peer_id and panel._main_player) then 
				DownCounterStandalone._set_downs_amount_string(panel,num)
				break
			end
		end
	end
end

function DownCounterStandalone:SetHUDVisible(peer_id,state)
	if managers.hud and managers.hud._teammate_panels then 
		local my_peer_id = managers.network:session():local_peer():id()
		for _,panel in pairs(managers.hud._teammate_panels) do 
			if peer_id == "all" or peer_id == panel._peer_id or (peer_id == my_peer_id and panel._main_player) then 
				local radial_health = panel._radial_health_panel
				local downs_text = alive(radial_health) and radial_health:child("downs")
				if alive(downs_text) then 
					downs_text:set_visible(state)
				end
			end
		end
	end
end

function DownCounterStandalone:IsHUDEnabled()
	return DownCounterStandalone.settings.hudmode
end

Hooks:Add("LocalizationManagerPostInit", "dcs_LocalizationManagerPostInit", function( loc )
	if not BeardLib then 
		loc:load_localization_file( DownCounterStandalone._localization_path .. "en.txt")
	end
end)

function DownCounterStandalone:Load()
	local file = io.open(self._data_path, "r")
	if (file) then
		for k, v in pairs(json.decode(file:read("*all"))) do
			self.settings[k] = v
		end
	else
		DownCounterStandalone:Save() --create data in case there's no mod save data
	end
end

function DownCounterStandalone:Save()
	local file = io.open(self._data_path,"w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_dcs", function(menu_manager)

	MenuCallbackHandler.callback_dcs_docbags = function(self,item)
		DownCounterStandalone.settings.announce_docbags = item:value() == "on"
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_networking = function(self,item)
		local value = item:value() == "on"
		DownCounterStandalone.settings.networking_enabled = value
		if value then 
			DownCounterStandalone:SendDownsDataToAll()
		else
			LuaNetworking:SendToPeers(DownCounterStandalone.ModID, DownCounterStandalone.NETWORK_MESSAGE_UNREGISTER)
		end
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_custody = function(self,item)
		DownCounterStandalone.settings.announce_custody = item:value() == "on"
		DownCounterStandalone:Save()
	end

	MenuCallbackHandler.callback_dcs_downs_low = function(self,item)
		DownCounterStandalone.settings.only_announce_lowdowns_mode = item:value() == "on"
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_extras = function(self,item)
		DownCounterStandalone.settings.announce_extras = item:value() == "on"
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_count_player_revives = function(self,item)
		local value = item:value() == "on"
		DownCounterStandalone.settings.show_player_revives = value
		
		local session = managers.network and managers.network:session()
		if session then 
			local peer = session:local_peer()
			if peer then 
				local peer_id = peer:id()
				for _,panel in pairs(managers.hud._teammate_panels) do 
					if panel._main_player then 
					
						local num
						if value then 
							num = DownCounterStandalone:GetRevives(peer_id)
							color = DownCounterStandalone.color_data.counter_revives
						else
							num = DownCounterStandalone:GetDowns(peer_id)
							color = DownCounterStandalone.color_data.counter_downs
						end
						
						DownCounterStandalone._set_downs_amount_string(panel,num)
						DownCounterStandalone._set_downs_amount_color(panel,color)
							
						break
					end
				end
			end
		end
		
		DownCounterStandalone:Save()
	end
	MenuCallbackHandler.callback_dcs_show_teammate_revives = function(self,item)
		local value = item:value() == "on"
		DownCounterStandalone.settings.show_teammate_revives = value
		local session = managers.network and managers.network:session()
		if session then 
		
			for _,peer in ipairs(session:all_peers()) do 
				for panel_id,panel in pairs(managers.hud._teammate_panels) do 
					local peer_id = panel:peer_id()
					if peer_id and not panel._main_player then 
						local num
						if value then 
							num = DownCounterStandalone:GetRevives(peer_id)
							color = DownCounterStandalone.color_data.counter_revives
						else
							num = DownCounterStandalone:GetDowns(peer_id)
							color = DownCounterStandalone.color_data.counter_downs
						end
						
						DownCounterStandalone._set_downs_amount_string(panel,num)
						DownCounterStandalone._set_downs_amount_color(panel,color)
					end
				end
			end			
		end
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_chatmode = function(self,item)
		DownCounterStandalone.settings.announce_chat_mode = tonumber(item:value())
		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_alertmode = function(self,item)
		DownCounterStandalone.settings.announce_alert_mode = tonumber(item:value())
		DownCounterStandalone:Save()
	end	
	
	MenuCallbackHandler.callback_dcs_hudmode = function(self,item)
		local value = item:value() == "on"
		DownCounterStandalone.settings.hudmode = value
		DownCounterStandalone:SetHUDVisible("all",value)

		DownCounterStandalone:Save()
	end
	
	MenuCallbackHandler.callback_dcs_close = function(this)
		DownCounterStandalone:Save()
	end
	DownCounterStandalone:Load()
	MenuHelper:LoadFromJsonFile(DownCounterStandalone._path .. "options.txt", DownCounterStandalone, DownCounterStandalone.settings)	
	
end)