Hooks:PreHook(UnitNetworkHandler, "sync_doctor_bag_taken", "dcs_unitnetworkhandler_syncdoctorbagtaken", function(self, unit, amount, sender, ...)
	local peer = self._verify_sender(sender) --gets data about player such as username, peerid, steamid64, internal char name etc.
	
	
	if not alive(unit) or not self._verify_gamestate(self._gamestate_filter.any_ingame) or not peer then
		return
	end
	local peer_id = 420
	local player_name = "ChadHeister McSexHaver"
	if peer then
		peer_id = peer:id() or peer_id
		player_name = peer:name() or player_name
	else
--		DownCounterStandalone:_log("Error- sync_doctor_bag_taken() could not verify sender. \n" .. debug.traceback())
		return
	end
	
	local downs = DownCounterStandalone:GetDowns(peer_id)
	DownCounterStandalone:SetDowns(peer_id,0)
	
	if DownCounterStandalone:IsAlertModeAll() or DownCounterStandalone:IsAlertModeTeammates() then
		
		local message
		if downs == DownCounterStandalone.LOW_LIVES_THRESHOLD then 
			message = managers.localization:text("hud_dcs_announcement_criminal_used_docbag_singular")
		else
			message = managers.localization:text("hud_dcs_announcement_criminal_used_docbag_plural")		
		end
		if downs == DownCounterStandalone.LOW_DOWNS_SHAMING_THRESHOLD then 
			message = message .. " " .. managers.localization:text(DownCounterStandalone._docbag_shaming_messages.third[math.random(#DownCounterStandalone._docbag_shaming_messages.third)])
		end
		
		
		if message then 
			message = string.gsub(message,"$PLAYER",player_name)
			message = string.gsub(message,"$NUM",downs)
			DownCounterStandalone:Announce(message)
		end
	end
end)

Hooks:PreHook(UnitNetworkHandler, "sync_player_movement_state", "dcs_unitnetworkhandler_syncplayermovementstate", function(self, unit, state, down_time, unit_id_str, sender)
	
	if not self._verify_gamestate(self._gamestate_filter.any_ingame) then
		return
	end

	local peer = self._verify_sender(sender)
	
	if not peer then
		return
	end

	if not alive(unit) then
		--DownCounterStandalone:_log("Error! Invalid unit in UnitNetworkHandler:sync_player_movement_state.")
		return
	end
	
	if not alive(peer:unit()) or peer:unit():key() ~= unit:key() then
--		DownCounterStandalone:_log("invalid unit for peer " .. tostring(peer:id()))
		return
	end

	local peer_id = peer:id()
	local player_name = peer:name() or "ChadHeister McSexHaver" --LuaNetworking:GetNameFromPeerID( peer_id ) 
	local rollem = math.random()
	local message
	local downs_count_text = ""
	local downs = DownCounterStandalone:GetDowns(peer_id)
	if state == "bleed_out" or state == "dead" then 
		downs = downs + 1
		DownCounterStandalone:SetDowns(peer_id,downs)
	end	
	if downs > 1 then
		downs_count_text = managers.localization:text("hud_dcs_announcement_criminal_downs_count_plural")	
	elseif downs == 1 then 
		downs_count_text = managers.localization:text("hud_dcs_announcement_criminal_downs_count_singular")	
	end
	
	if state == "dead" then
		DownCounterStandalone:SetDowns(peer_id,0)
		
		if not DownCounterStandalone:AnnounceCustodies() then 
			--when teammate goes into custody, do not announce custody, and do not announce that they went down. you know, cause they went into custody
			return
		end
		if rollem < DownCounterStandalone.ANNOUNCE_DEAD_VARIANT_CHANCE then 
			message = managers.localization:text("hud_dcs_announcement_criminal_state_dead_variant_2")	
		else
			message = managers.localization:text("hud_dcs_announcement_criminal_state_dead_variant_1")	
		end

		message = message .. " " .. downs_count_text
		

	elseif state == "bleed_out" then
		
		local low_downs = DownCounterStandalone:GetRevives(peer_id) <= 1
		if low_downs and DownCounterStandalone:ShouldShowTeammateRevives() then 
			message = managers.localization:text("hud_dcs_announcement_criminal_state_bleedout_low_revives")
		elseif not DownCounterStandalone:IsAnnounceLowDownsOnly() and (DownCounterStandalone:IsAlertModeAll() or DownCounterStandalone:IsAlertModeTeammates()) then
			message = managers.localization:text("hud_dcs_announcement_criminal_state_bleedout")
		else
			--don't say anything if: 1. high revives remain and not announce low downs, and 2. DCS mode is not set to announce team downs
			return
		end
		
		message = message .. " " .. downs_count_text

	elseif state == "arrested" then
		if DownCounterStandalone:AnnounceExtraStates() then 
			message = managers.localization:text("hud_dcs_announcement_criminal_state_cuffed")	
		else
			return
		end
	elseif state == "incapacitated" then 
		if DownCounterStandalone:AnnounceExtraStates() then 	
			message = managers.localization:text("hud_dcs_announcement_criminal_state_incapacitated")	
		else
			return
		end
	elseif state == "tased" then 
		if DownCounterStandalone:AnnounceExtraStates() then
			message = managers.localization:text("hud_dcs_announcement_criminal_state_tased")	
		else
			return
		end
	elseif state == "fatal" then --downed and out, full bleed-out, no weapon, view tilted 90 degrees, fall to the floor, walk the dinosaur
		if DownCounterStandalone:AnnounceExtraStates() then
			message = managers.localization:text("hud_dcs_announcement_criminal_state_fatal")	
		else
			return
		end
	else
		--don't announce anything
		return
	end
	
	if message then 
		message = string.gsub(message,"$PLAYER",player_name)
		message = string.gsub(message,"$NUM",downs)
		DownCounterStandalone:Announce(message)
	end
end)

Hooks:PostHook(UnitNetworkHandler,"on_sole_criminal_respawned","dcs_unitnetworkhandler_onsolecriminalrespawned",function(self,peer_id, sender)
	DownCounterStandalone:SetDowns(peer_id,0)
end)